// Simple Reed-Solomon encode-decode test
// generates random data, adds random errors and decodes 10,000 times
// Copyright 1999 Phil Karn
// May be used under the terms of the GNU Public License (GPL)

#define NERR 18 // Number of errors to introduce (and erasures to flag)

#include <stdio.h>
#include "galois.h"
#include "rs.h"

main()
{
  int i,j;
  int block;
  init_galois();
  rs_init();

  dtype message[NN];
  int epos[NERR];
  int nerrs;
  dtype cmessage[NN];

  for(block=0;block<10000;block++){
    for(i=0;i<KK;i++)
      message[i] = random();

    encode_rs(message,&message[KK]);
    // introduce errors for test
    for(nerrs = 0;nerrs < NERR;){
      int r;
      r = random() & NN;
      if(r == NN)
	continue;
      for(i=0;i<nerrs;i++)
	if(epos[i] == r)
	  goto skip; // duplicate
      epos[nerrs++] = r;
    skip:;
    }
    for(i=0;i<NN;i++)
      cmessage[i] = message[i];
    
    for(i=0;i<NERR;i++){
      int eval;
      do {
	eval = random() & NN;
      } while(eval != 0);
      cmessage[epos[i]] ^= eval;
    }
    //    eras_dec_rs(cmessage, epos, NERR);
    eras_dec_rs(cmessage, epos, NERR-2);
    // check for correct answer
    for(i=0;i<NN;i++)
      if(cmessage[i] != message[i])
	printf("decoding error, block %d!\n",block);
    if((block % 1000) == 0)
      printf("block %d OK\n",block);
  }
}
